; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     normal  read  readvalue  sort
; -----------------------------------------------------------------------
;   Macro       SMS5num
; -----------------------------------------------------------------------
;   Description  SMS5num computes the Five Number Summary for U.S. Cities 
;								 and for normal distributed data with chosen number of 
;								 observation
; -----------------------------------------------------------------------

library("stats")																		; loads library stats
setenv("outputstringformat", "%s")									; sets the output format


ValueNames = "Number of observation ="              ; reads the number of observation 
defaults = 15
v = readvalue(ValueNames, defaults)

error(v[1]<=0, "Choose at least one observation")   ; error varning 
error(v[1]>50, "There are max. 50 observation")     ; error varning 
x = read("uscrime")[,1]															; reads the U.S. Crime Data
x = sort(x,-1)      																		; sorts the data
x = x[1:(v[1])]                                     ; takes the largest cities
fivenum(x)																					; five number summary for the U.S. Cities
randomize(0)
y = normal(v[1])																		; generates standard normal distributed data
fivenum(y)

