; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also     grbox grrot grmove createdisplay show setgopt
; ----------------------------------------------------------------------------
;   Macro       SMSboxbank6
; ----------------------------------------------------------------------------
;   Description  SMSboxbank6 computes Boxplots for the diagonal (Variable 6) 
;                of the genuine and forged banknotes from bank2.dat, 
;                respectively
; ----------------------------------------------------------------------------
 x=read("bank2")                        ; reads the data file
 library("graphic")                     ; loads the graphic library
;
 bpg=grbox(x[1:100,6])                  ; boxplot for diagonals (genuine notes)
 bpf=grbox(x[101:200,6])                ; boxplot for diagonals (forged  notes)
 grg=grrot(bpg,1)                       ; rotation of the plot
 grf=grrot(bpf,1)                       ; rotation of the plot
;
 go=grmove(grf,#(1.5,0))                ; moves the plot of the forged notes to the right
 axesoff()
 axes=graxes((-0.5|3)~((min(x[,6])-0.05*(max(x[,6])-min(x[,6])))|max(x[,6])),"origin",7.5,"ytextpos",9,"xtextpos",6,"xticks",0.5|2,"xtext","GENUINE"|"COUNTERFEIT","xtextsize",16,"ytextsize",16)
 di=createdisplay(1,1)                  ; create display "di"
 show(di,1,1,go,grg,axes)                    ; show boxplots
 setgopt(di,1,1,"title","Swiss bank notes","border",0)
 ; setgopt(di,1,1,"title","swiss bank notes","xlim",#(-0.5,3),"ylabel","diagonal","xmajor",0)


