; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     grbox grrot grmove createdisplay show setgopt
; -----------------------------------------------------------------------
;   Macro       SMSboxcar
; -----------------------------------------------------------------------
;   Description  SMSboxcar computes Boxplots for the mileage (Variable 14) 
;                of US, Japanese and European cars from carc.dat, 
;                respectively
; -----------------------------------------------------------------------
 library("graphic")
 x=read("carc")                   ; reads the whole car data file
 x1=paf(x[,3],x[,14].=1)          ; mileage for US cars
 x2=paf(x[,3],x[,14].=2)          ; mileage for Japanese cars
 x3=paf(x[,3],x[,14].=3)          ; mileage for European cars
 ;
 bp1=grbox(x1)                    ; boxplot for US cars
 bp2=grbox(x2)                    ; boxplot for Japanese cars
 bp3=grbox(x3)                    ; boxplot for European cars
 gr1=grrot(bp1,1)                 ; rotation of the plot
 gr2=grrot(bp2,1)                 ; rotation of the plot
 gr3=grrot(bp3,1)                 ; rotation of the plot
 ;
 go2=grmove(gr2,#(1.5,0))         ; moves plot of Japanese to right
 go3=grmove(gr3,#(3,0))           ; moves plot of European to right
 axesoff()
 axes=graxes((-0.5|4.5)~((min(x[,3])-0.05*(max(x[,3])-min(x[,3])))|max(x[,3])),"origin",7.5,"ytextpos",9,"xtextpos",6,"xticks",0.5|2|3.5,"xtext","US"|"JAPAN"|"EU","xtextsize",16)
 di=createdisplay(1,1)            ; create display "di"
 show(di,1,1,gr1,go2,go3,axes)         ; shows the 3 boxplots 
 ylabl="mileage"
; setgopt(di,1,1,"title","car data","xlim",#(-0.5,4.5),"ylabel",ylabl,"xmajor",0)

