; ----------------------------------------------------------------------------
; EBook          sms
; ----------------------------------------------------------------------------
;  See_also      cov diag eigsm svdcmp setmaskp setmaskt plot setgopt
; ----------------------------------------------------------------------------
;   Macro        SMScanus
; ----------------------------------------------------------------------------
;   Description  SMScanus performs a canonical correlation analysis 
;                for the US health and US crime data 
; ----------------------------------------------------------------------------
library("xplore")
library("plot")
x=read("uscrime")
x=x[,3:9]
x=(x-mean(x))./sqrt(var(x))
;x=x/sqrt(x)
y=read("ushealth")
y=y[,4:10]
y=(y-mean(y))./sqrt(var(y))

;y=y/sqrt(y)
sxx=cov(x)
syy=cov(y)
sxy=cov(x~y)[1:7,8:14]
{eval,evec}=eigsm(sxx)           ; square root of sxx
sxx12=evec*(sqrt(diag(1/eval)))*evec'
{eval,evec}=eigsm(syy)           ; square root of syy
syy12=evec*(sqrt(diag(1/eval)))*evec'
k=sxx12*sxy*syy12
{gamma,l,delta}=svd(k)
l
a=sxx12*gamma
a
b=syy12*delta
b
eta=x*a
phi=y*b
;plotsplom(x~y,grc.prep.none)
  xrows="ME"|"NH"|"VT"|"MA"
  xrows=xrows|"RI"|"CT"|"NY"|"NJ"
  xrows=xrows|"PA"|"OH"|"IN"|"IL"
  xrows=xrows|"MI"|"WI"|"MN"|"IA"
  xrows=xrows|"MO"|"ND"|"SD"|"NE"
  xrows=xrows|"KS"|"DE"|"MD"|"VA"
  xrows=xrows|"WV"|"NC"|"SC"|"GA"
  xrows=xrows|"FL"|"KY"|"TN"|"AL"
  xrows=xrows|"MS"|"AR"|"LA"|"OK"
  xrows=xrows|"TX"|"MT"|"ID"|"WY"
  xrows=xrows|"CO"|"NM"|"AZ"|"UT"
  xrows=xrows|"NV"|"WA"|"OR"|"CA"
  xrows=xrows|"AK"|"HI"
  etaphi=eta[,1]~phi[,1] 
;  
  setmaskt(etaphi,xrows,0,0,15) ; add text labels
  setmaskp(etaphi,0,0,0)        ; no points
  plot(etaphi)
  setgopt(plotdisplay,1,1,"title","US health and crime data","xlabel","eta1","ylabel","phi1")

;plot(eta[,1]~phi[,1])



