; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also  read grid setmaskp setmaskt createdisplay show setgopt
; ----------------------------------------------------------------------------
;   Macro        SMScapmnyse
; ----------------------------------------------------------------------------
;   Description  SMScapmnyse computes the betas 
;                from monthly returns of six US firms from 
;                Jan'78 to Dec'87 using IBM as the market index. 
; ----------------------------------------------------------------------------
  library("xplore")
  library("stats")
  setenv("outputformat","% 5.4f")
;
  x1=read("ibm")               ; returns for IBM
  x2=read("panam")             ; returns for Pan Am. Airways
  x3=read("delta")             ; returns for Delta Airlines
  x4=read("coned")             ; returns for Cons. Edison
  x5=read("gerber")            ; returns for Gerber
  x6=read("texaco")            ; returns for Texaco
  x7=read("dec")               ; returns for Digital Equipment Company
;
  ix=1|2|3|4|5|6|7             ; CHOOSE assets to use!!
  ix=1|2|7
;
  x=x1~x2~x3~x4~x5~x6~x7       ; MVAportfolio of all assets
  x=x[,ix]                     ; use only ix
;
  l1=linreg(x[,1],x[,2]) ; PanAm
  l2=linreg(x[,1],x[,3]) ; DEC

  l1.beta
  l2.beta

;
  ;t=min(x[,1])|max(x[,1]) 
  t2=max(abs(x[,1]|x[,2]|x[,3]))
  t=-t2|t2
  de=(1|1)~t   
  d1=t~(de*l1.beta)                      ; reg line panam
  d2=t~(de*l2.beta)                      ; reg line dec
  p1=x[,1|2]
  p2=x[,1|3]
;
  setmaskl(d1, 1~2, 0, 1)  ; creates a solid line for 
  setmaskp(d1, 0, 0, 0)        ; the reg function 
  setmaskp(p1, 1, 3, 4)        ; points  panam
 setmaskl(d2, 1~2, 0, 1)  ; creates a solid line for 
  setmaskp(d2, 0, 0, 0)        ; the reg function 
  setmaskp(p2, 1, 3, 4)        ; points  dec
;
  str=" IBM"|" Pan Am"|" Delta"|" Edison"|" Gerber"|" Texaco"
  ;str1=" IBM"|" Pan Am"
  setsize(600,300)
  di=createdisplay(1,2)
  ;setfractions(di,1|1,3|1)
  show(di,1,1,d1,p1)
  show(di,1,2,d2,p2)
  ;show(di,1,2,"weights"|" "|(string("%0.3f",c1)+str))
  ;show(di,2,2,"weights"|" "|(string("%0.3f",c2)+str))
  ;show(di,1,2,"weights"|" "|(string("%0.3f",c1)+str1)) ;show only IBM and Pan Am
  ;show(di,2,2,"weights"|" "|(string("%0.3f",c2)+str1)) ;show only IBM and Pan Am
  setgopt(di,1,1,"xlim",-t2|t2,"ylim",-t2|t2,"yvalue",0|1,"ymajor",0.2,"title","PanAm vs. IBM","border",0)
  setgopt(di,1,2,"xlim",-t2|t2,"ylim",-t2|t2,"yvalue",0|1,"ymajor",0.2,"title","DEC vs. IBM","border",0)
  setgopt(di,1,1,"ylabel","PanAm","xlabel","IBM")
  setgopt(di,1,2,"ylabel","DEC","xlabel","IBM")
  "variance efficient portfolio"
  c2
