; ----------------------------------------------------------------------------
; EBook          sms
; ----------------------------------------------------------------------------
;  See_also      cartsplitclass
; ----------------------------------------------------------------------------
;   Macro        SMScartdiag
; ----------------------------------------------------------------------------
;   Description  SMScartdiag performs CART on the diagonal data set
; ----------------------------------------------------------------------------

library("xclust");
 
 proc(y)=tuto(seed,n)
   randomize(seed)
   xdat=uniform(n,2)
   index=(xdat[,1].>xdat[,2])+1
   layout=10*(index==1)+8.*(index==2)
   color=1*(index==1)+0.*(index==2)
   ydat=index
   y=list(xdat,ydat,layout,color)
 endp

 proc(xy,dm)=points(sv,vr,x,y,data)
	; sv is list
	; vr is vector
  di=createdisplay(1,2)

  setmaskp(x, data.color, data.layout, 10)
  show(di,1,1,x)
  setgopt(di,1,1,"title","diagonal data set","border",0)
  dlin=(0~0)|(1~1)
  setmaskp(dlin, 0, 0, 0)
  setmaskl(dlin,1~2,0,1,2)
  adddata(di, 1, 1, dlin)

  setmaskp(x, data.color, data.layout, 10)
  show(di,1,2,x)
  setgopt(di,1,2,"title","diagonal data set","border",0)
	n=rows(vr)
	i=1
	sv2=vr
	while (i<=27)
	 sv2[i]=atof(sv{i})	
	 if (vr[i]==1) 
	 	x=grxline(sv2[i],0|1)
	 	adddata(di,1,2,x)
	 endif
	 if (vr[i]==2) 
	 	x=gryline(sv2[i],0|1)
	 	adddata(di,1,2,x)
	 endif
	i=i+1
	endo
	xy=sv2
	dm=vr
 endp

 library("xclust")
 library("plot")
 di=createdisplay(1,1)
 data=tuto(1,100)
 x=data.xdat
 y=data.ydat

 tr = cartsplitclass(x,y,0,1)

 setsize(600,300)
 points(tr.SplitValue,tr.Variable,x,y,data)

 setsize(500,500)
 cartdisptree(tr)

; for nice looking latex picture
; cartdrawpdfclass(x,y,0,1, "R:\temp\SMScartdiag.tex");

