; ----------------------------------------------------------------------------
; EBook          sms
; ----------------------------------------------------------------------------
;  See_also      cartsplitclass
; ----------------------------------------------------------------------------
;   Macro        SMScartsq
; ----------------------------------------------------------------------------
;   Description  SMScartsq performs CART on an ideal data set
; ----------------------------------------------------------------------------

 library("xclust");
 
 proc(y)=tuto(seed,n)
   randomize(seed)
   xdat=uniform(n,2)
   index=1+(xdat[,2]<=0.5)+(xdat[,2]<=0.5).*(xdat[,1]<=0.5)+(xdat[,2]>0.5).*(xdat[,1]<=0.5).*(xdat[,2]>0.75)
   layout=10*(index==1)+8.*(index==2)+7.*(index==3)
   color=1*(index==1)+0.*(index==2)+4.*(index==3)
   ydat=index
   y=list(xdat,ydat,layout,color)
 endp

 library("xclust")
 di=createdisplay(1,1)
 data=tuto(1,100)
 x=data.xdat
 setmaskp(x, data.color, data.layout, 10)
 show(di,1,1,x)
 setgopt(di,1,1,"title","CART example","border",0)
 
 x=x
 y=data.ydat

;x = #(1,2,3,4,40,50,60,80,90, 100, 110, 300, 500)~#(10,0,40,60,100,1,-91,20,20,34, 1, 3, -5);
;y = #(1,1,1,1,2,1,1,2,3,2, 3, 3, 3)
tr = cartsplitclass(x,y,0,1)
cartdisptree(tr)

; for nice looking latex picture
; cartdrawpdfclass(x,y,0,1, "R:\temp\SMScartsq.tex");

