; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also     cols mean matrix qfc sum 
; ----------------------------------------------------------------------------
;   Macro       SMSchi2bac
; ----------------------------------------------------------------------------
;   Description  SMSchi2bac the chi-square statistic of independence (see the MVA,
;								 Correspondence analysis) for the French baccalaureaut data.
; ----------------------------------------------------------------------------
x = read("bac")						; read the data
n = rows(x)
p = cols(x)
x = x[,2:p]

cc = n*mean(x)						; sums of columns
rr = p*mean(x')						; sums of rows
s = sum(cc')							; sum of all data

E = 0*matrix(n,p)					; estimated expected values
E = (1/s)*rr'*cc
;E
t = ((x-E).*(x-E))./E			; the test statistic
t = sum(sum(t)')
t
qfc(0.95,((n-1)*(p-1)))		; corresponding quantile of chi-square distribution

