; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      agglom tree
; ----------------------------------------------------------------------------
;   Macro        SMSclus8p
; ----------------------------------------------------------------------------
;   Description  SMSclus8p performs cluster analysis for the 8 points example 
; ----------------------------------------------------------------------------
x=#(5, 2, (-2), (-3), (-2), (-2), 1, 1)~#( (-3), (-4), (-1), 0, (-2), 4, 2, 4)
                              ; creates data
n=rows(x)                     ; rows of data
xs=string("%1.0f", 1:n)       ; adds labels
setsize(600, 300)
dd=createdisplay(1,2) 
dd2=createdisplay(1,2)
setmaskp(x, 0, 0, 0)
setmaskt(x, string("%.0f", 1:rows(x)), 4, 9, 16)
setmaskl(x, 1~2~5~0~7~8~6~0~7~3~5~0~3~4, 0, 1, 1)
show(dd, 1, 1, x)            ; shows data -> BRUSH!!
setgopt(dd, 1, 1, "xlabel", "first coordinate", "ylabel", "second coordinate")
setgopt(dd, 1, 1, "title", " 8 points", "xoffset", 10|10, "yoffset", 10|10, "ylim", -4.5|4.5,"border",0)
setmaskl(x, 2~1~6~7~8~5~4~0~5~3, 0, 1, 1)
show(dd2, 1, 1, x)            ; shows data -> BRUSH!!
setgopt(dd2, 1, 1, "xlabel", "first coordinate", "ylabel", "second coordinate")
setgopt(dd2, 1, 1, "title", " 8 points", "xoffset", 10|10, "yoffset", 10|10, "ylim", -4.5|4.5,"border",0)
; the second part
d=distance(x, "euclid")       ; Euclidean distance
d.*d                          ; squared distance matrix
t=agglom(d.*d, "ward", 5)  ; hier. cluster anal., Single linkage 
t2=agglom(d.*d, "complete", 5)  ; hier. cluster anal., Single linkage 
g=tree(t.g, 0, "CENTER")
g=g.points
g2=tree(t2.g, 0, "CENTER")
g2=g2.points
l = 5.*(1:rows(g)/5) + (0:4)' - 4 
l2 = 5.*(1:rows(g2)/5) + (0:4)' - 4 
setmaskl (g, l, 0, 1, 1) 
setmaskp (g, 0, 0, 0) 
setmaskl (g2, l, 0, 1, 1) 
setmaskp (g2, 0, 0, 0) 
; show the dendrogram 
tg=paf(t.g[,2], t.g[,2]!=0)
tg2=paf(t2.g[,2], t2.g[,2]!=0)
numbers=(0:(rows(x)-1))
numbers=numbers~((-1)*matrix(rows(x)))
setmaskp(numbers, 0, 0, 0)
setmaskt(numbers, string("%.0f", tg), 0, 0, 16)  
show (dd, 1, 2, g, numbers) 
setgopt(dd, 1, 2, "xlabel"," " , "ylabel","Squared Euclidian Distance" )
setgopt(dd, 1, 2, "title", "Ward Dendrogram - 8 points", "xoffset", 10|10, "yoffset", 10|3,"border",0)  
setmaskt(numbers, string("%.0f", tg2), 0, 0, 16)  
show (dd2, 1, 2, g2, numbers) 
setgopt(dd2, 1, 2, "xlabel"," " , "ylabel","Squared Euclidian Distance" )
setgopt(dd2, 1, 2, "title", "Complete Linkage Dendrogram - 8 points", "xoffset", 10|10, "yoffset", 10|3,"border",0)  
