; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      agglom tree distance
; ----------------------------------------------------------------------------
;   Macro        SMSclusbank2
; ----------------------------------------------------------------------------
;   Description  SMSclusbank2 performs cluster analysis for  20 
;                randomly chosen banknotes from 
;                the swiss banknotes dataset 
; ----------------------------------------------------------------------------
library("xplore")
proc()=main()
 setsize(500, 300)
 dd=createdisplay(1,1)
 dd2=createdisplay(1,1)
 x=read("bank2")                 ; reads data
 randomize(2006)                 ; sets random seed
 n=20                            ; sample size
; xi=1:10  
 xi=ceil(200*uniform(n))         ; indices of chosen subsample
; xi=37|32|3|98|67|50|89|171|116|168|148|194|108|135|193|145|165|114|146|173
 xx=index(x, xi)                 ; extracts subsample from x
 xxi=string("%3.0f", xi)         ; labels
 ;
 x=xx-mean(xx)
 {e, v}=eigsm(cov(x))            ; eigensystem analysis
 tmp=sort(e~v',-1)               ; sort by eigenvalues
 e=tmp[,1]
 v=tmp[,2:7]
 y=x*(v')                        ; PCA transformation
 y=y[,1:2]
 tc=(xi<101)
 labels=string("%.0f", xi)
 setmaskt(y, labels, tc, 0, 14)
 setmaskp(y, 0, 0, 0)
 ;
 ; second part
 d=distance(xx, "euclid")        ; Euclidean distance
 t=agglom(d.*d, "single", 5)       ; here. cluster anal.
 g=tree(t.g, 0, "CENTER")
 g=g.points
 t2=agglom(d.*d, "complete", 5)       ; here. cluster anal. complete link
 g2=tree(t2.g, 0, "CENTER")
 g2=g2.points
 l = 5.*(1:rows(g)/5) + (0:4)' - 4 
 setmaskl (g, l, 0, 1, 1) 
 setmaskp (g, 0, 0, 0) 
 setmaskl (g2, l, 0, 1, 1) 
 setmaskp (g2, 0, 0, 0) 
 ; show the dendrogram 
 numbers=(0:(rows(xx)-1))
 numbers2=numbers~((-1)*matrix(rows(xx)))
 numbers=numbers~((-0.25)*matrix(rows(xx)))
 setmaskp(numbers2, 0, 0, 0)
 tg2=paf(t2.g[,2], t2.g[,2]!=0)
 labels2=string("%.0f", xi[tg2])
 setmaskp(numbers, 0, 0, 0)
 tg=paf(t.g[,2], t.g[,2]!=0)
 labels=string("%.0f", xi[tg])
 setmaskt(numbers2, labels2, 0, 0, 10)  
 setmaskt(numbers, labels, 0, 0, 10)  
; ddd=createdisplay(1, 1)
 show(dd, 1, 1, g, numbers) 
 setgopt(dd, 1, 1, "xlabel"," " , "ylabel","Squared Euclidian Distance" )
 setgopt(dd, 1, 1, "title", "Dendrogram for 20 Swiss bank notes, Single linkage ", "xoffset", 10|10, "yoffset", 10|10)  
 setgopt(dd, 1, 1, "xmajor", 50, "xorigin", -10, "border", 0)
 show(dd2, 1, 1, g2, numbers2) 
 setgopt(dd2, 1, 1 , "xlabel"," ","ylabel","Squared Euclidian Distance" )
 setgopt(dd2, 1, 1, "title", "Dendrogram for 20 Swiss bank notes, Complete linkage ", "xoffset", 10|10, "yoffset", 10|10)  
 setgopt(dd2, 1, 1, "xmajor", 50, "xorigin", -10, "border", 0)
endp                                 
main()