; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      agglom tree distance grrot
; ----------------------------------------------------------------------------
;   Macro        SMScluscomp
; ----------------------------------------------------------------------------
;   Description  SMScluscomp performs cluster analysis for   
;                US companies
; ----------------------------------------------------------------------------
library("xplore")
library("graphic")
 setsize(500, 500)
 dd=createdisplay(1,1)
 setsize(500, 500)
 ddd2=createdisplay(1,1)
 setsize(500,800)
 y=readm("uscomp2")                 ; reads data
 xx=y.double
 xxi=substr(y.text[,2],1,3)
 xxxi=y.text[,1]
 n=rows(xx)                            ; sample size
 ;
 ;x=xx-mean(xx)
; xx=(xx-mean(xx))/sqrt(var(xx))
 xxp=log(xx-min(xx)+(max(xx)-min(xx))/200) 
 xx=(xx-mean(xx))/sqrt(var(xx))
 {e, v}=eigsm(cov(xxp))            ; eigensystem analysis
 tmp=sort(e~v',-1)               ; sort by eigenvalues
 e=tmp[,1]
 v=tmp[,2:7]
 y=xxp*(v')                        ; PCA transformation
 y=y[,1:2]
 y2=y
 tc=matrix(n)
 labels=xxxi
 setmaskt(y, labels, tc, 0, 14)
 setmaskp(y, 0, 0, 0)
 show(dd, 1, 1, y)
 setgopt(dd, 1, 1, "xlabel", "first PC", "ylabel", "second PC")
 setgopt(dd, 1, 1, "title", "US Companies")
 setgopt(dd, 1, 1, "xoffset", 10|10, "yoffset", 10|10, "border", 0)
 ;print(dd, "fig114.ps")
 ;error()
 ;
 ; second part
 d=distance(xx, "l1")        ; L1 distance
 t=agglom(d, "WARD", 5)       ; here. cluster anal., Ward algor.
 g=tree(t.g, 0, "CENTER")
 g=g.points
 l = 5.*(1:rows(g)/5) + (0:4)' - 4 
 setmaskl (g, l, 0, 1, 1) 
 setmaskp (g, 0, 0, 0) 
 ; show the dendrogram 
 numbers=(0:(rows(xx)-1))
; numbers=numbers~((-4950)*matrix(rows(xx)))
 numbers=numbers~((-1)*matrix(rows(xx)))
 setmaskp(numbers, 0, 0, 0)
 tg=paf(t.g[,2], t.g[,2]!=0)
 labels=xxi

 setmaskt(y2, labels, 0, 6, 12)
 setmaskp(y2, 0, t.p*2 , 10)
 show(ddd2, 1, 1, y2)
 setgopt(ddd2, 1, 1, "xlabel", "first PC", "ylabel", "second PC")
 setgopt(ddd2, 1, 1, "title", "Five Clusters for US Companies")
 setgopt(ddd2, 1, 1, "xoffset", 10|10, "yoffset", 10|10, "border", 0)
 labels=xxi[tg]


 setmaskt(numbers, labels, 0, 0, 10)  
 ddd=createdisplay(1, 1)
 g=grrot(g,3)
 numbers=grrot(numbers,3)
 show(ddd, 1, 1, g, numbers) 
 setgopt(ddd, 1, 1, "ylabel"," " , "xlabel"," " )
 setgopt(ddd, 1, 1, "title", "Dendrogram for US companies, Ward algorithm", "yoffset", 5|5, "xoffset", 5|5)  
 setgopt(ddd, 1, 1, "ymajor", 150, "yorigin", -10, "border", 0, "xvalue",0|1)