; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      agglom tree distance
; ----------------------------------------------------------------------------
;   Macro        SMSclushealth
; ----------------------------------------------------------------------------
;   Description  SMSclushealth performs cluster analysis for   
;                US health data set
; ----------------------------------------------------------------------------
library("xplore")
library("plot")
 setsize(500, 500)
 dd=createdisplay(1,1)
 setsize(600, 600)
 y=readm("ushealth")                      ; read data
 t=y.text
 reg=y.double[,12]
 xx=y.double[,3:9]
 xxi=string("%2.0f",reg)+" "+t
 xxxi=t
 n=rows(xx)                            ; sample size
 ;
 x=xx-mean(xx)
 ;xx=log(xx-min(xx)+(max(xx)-min(xx))/10) 
 ;xx=(xx-mean(xx));/sqrt(var(xx))
 {e, v}=eigsm(cov(xx))            ; eigensystem analysis
 tmp=sort(e~v',-1)               ; sort by eigenvalues
 e=tmp[,1]
 v=tmp[,2:cols(tmp)]
 y=xx*(v')                        ; PCA transformation
 y=y[,1:2]
 tc=matrix(n)
 labels=xxxi
 d=distance(xx, "euclid")        ; Euclidean distance
 t=agglom(d, "WARD", 4)       ; here. cluster anal., Ward algor.
 setmaskt(y, labels, 0, 0, 8+6*(t.p-1))
 setmaskp(y, 0, 0, 0)
 show(dd, 1, 1, y)
 setgopt(dd, 1, 1, "xlabel", "first PC", "ylabel", "second PC")
 setgopt(dd, 1, 1, "title", "US health")
 setgopt(dd, 1, 1, "xoffset", 10|10, "yoffset", 10|10, "border", 0)
 ;print(dd, "fig114.ps")
 ;error()
 ;
 ; second part
 g=tree(t.g, 0, "CENTER")
 g=g.points
 l = 5.*(1:rows(g)/5) + (0:4)' - 4 
 setmaskl (g, l, 0, 1, 1) 
 setmaskp (g, 0, 0, 0) 
 ; show the dendrogram 
 numbers=(0:(rows(xx)-1))
 numbers=numbers~((-40)*matrix(rows(xx)))
 setmaskp(numbers, 0, 0, 0)
 tg=paf(t.g[,2], t.g[,2]!=0)
 labels=xxi[tg]
 setmaskt(numbers, labels, 0, 0, 10)  
 ddd=createdisplay(1, 1)
 g=grrot(g,3)
 numbers=grrot(numbers,3) 
 show(ddd, 1, 1, g, numbers) 
 setgopt(ddd, 1, 1, "ylabel"," " , "xlabel","Euclidean distance" )
 setgopt(ddd, 1, 1, "title", "Dendrogram for US health, Ward algorithm", "xoffset", 10|10, "yoffset", 10|10)  
 setgopt(ddd, 1, 1, "xlim", -1010|80 , "ymajor", 150, "yorigin", -10, "border", 0)

 t=agglom(d, "WARD", 4)       ; here. cluster anal., Ward algor.

"Means for the four clusters"
"acc card canc pul pneu diab liv"
mean(paf(xx,t.p==1))
mean(paf(xx,t.p==2))
mean(paf(xx,t.p==3))
mean(paf(xx,t.p==4))
"cluster 1"
paf(xxxi,t.p==1)
"cluster 2"
paf(xxxi,t.p==2)
"cluster 3"
paf(xxxi,t.p==3)
"cluster 4"
paf(xxxi,t.p==4)
