; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      rows cols matrix diag eigsm sort string grxline gryline
;                createdisplay show setmaskp setgopt plot3d
; ----------------------------------------------------------------------------
;   Macro        SMSdecobank
; ----------------------------------------------------------------------------
;   Description  SMSdecofood computes a spectral decomposition of the Swiss 
;                bank notes data  and gives a representation the genuine and forged
;                bank notes 
; ----------------------------------------------------------------------------
 x=read("bank2")                 ; reads the food data 
 library("graphic")             ; loads graphic library
 library("plot")
 x=x[,1:cols(x)]
 n=rows(x)                      ; rows of data matrix 
 p=cols(x)                      ; columns of data matrix 
;                                
 one=matrix(n,n)
 h=diag(matrix(n))-one./n       ; centering matrix 
 d=diag(1./sqrt(sum((x-mean(x))^2)'/n))
 xs=h*x*d                       ; standardized data
;
 xs=xs./sqrt(n)                
 xs2=xs'*xs 
 {lambda, gamma}=eigsm(xs2)     ; spectral decomposition 
;
 tmp=sort(lambda~gamma',-1)     ; sort by eigenvalues
 lambda=tmp[,1]
 gamma=tmp[,2:cols(tmp)]'
;
 w=gamma.*(sqrt(lambda'))       ; coordinates of food 
 w=w[,1:3]                     ; 
 z=xs*gamma                     ; coordinates of families 
               ; z=sqrt(n/p).*z ; xs' scaled by square root of p 
 z=z[,1:3]                     ; 
;
 namew="X1"|"X2"|"X3"|"X4"|"X5"|"X6"
 namez=string("G",1:100)|string("F",1:100)
 tw=namew+" "+string("%6.3f", w[,1])+" "+string("%6.3f", w[,2])
 tz=namez+" "+string("%6.3f", z[,1])+" "+string("%6.3f", z[,2])
;
 setsize(500,500)
 axeson()
 di=createdisplay(2, 2)
 ly11=grxline(0, w[,2])          ; vertical axis
 lx11=gryline(0, w[,1])          ; horicontal axis
 lx22=gryline(0, w[,2]) 
 ly21=grxline(0, w[,3])
 
 l2y11=grxline(0, z[,2])          ; vertical axis
 l2x11=gryline(0, z[,1])          ; horicontal axis
 l2x22=gryline(0, z[,2]) 
 l2y21=grxline(0, z[,3])

;
 w12=w[,1:2]
 z12=z[,1:2]
 w13=w[,1|3]
 z13=z[,1|3]
 w23=w[,2:3]
 z23=z[,2:3]
 setmaskp(z, 0, 0, 0)
 setmaskt(z, namez, 0, 0, 12)
 setmaskp(w, 0, 0, 0)
 setmaskt(w, namew, 0, 0, 12)
 setmaskp(z12, 0, 0, 0)
 setmaskp(w12, 0, 0, 0)
 setmaskt(z12, namez, 0, 0, 12)
 setmaskt(w12, namew, 0, 0, 12)           
 setmaskp(z13, 0, 0, 0)
 setmaskp(w13, 0, 0, 0)
 setmaskt(z13, namez, 0, 0, 12)
 setmaskt(w13, namew, 0, 0, 12)           
 setmaskp(z23, 0, 0, 0)
 setmaskp(w23, 0, 0, 0)
 setmaskt(z23, namez, 0, 0, 12)
 setmaskt(w23, namew, 0, 0, 12)           
 show(di, 1, 1, w12, lx11, ly11 )
 setgopt(di, 1, 1, "title","variables","xlim",-1 | 1,"ylim", -1 |1)
 setgopt(di, 1, 1, "xlabel","W[,1]","ylabel","W[,2]","border",0)
 show(di, 2, 1, w13, lx11, ly21 )
 setgopt(di, 2, 1, "title","variables","xlim",-1 | 1,"ylim", -1 |1)
 setgopt(di, 2, 1, "xlabel","W[,1]","ylabel","W[,3]","border",0)
 show(di, 2, 2, w23, lx22, ly21 )
 setgopt(di, 2, 2, "title","variables","xlim",-1 | 1,"ylim", -1 |1)
 setgopt(di, 2, 2, "xlabel","W[,2]","ylabel","W[,3]","border",0)
 setgopt(di, 1, 2, "border",0)
;
 di2=createdisplay(2, 2)
 show(di2, 1, 1,  z12, l2x11, l2y11 )
 setgopt(di2, 1, 1, "title","bank notes") 
 setgopt(di2, 1, 1, "xlabel","Z[,1]","ylabel","Z[,2]","border",0)
 show(di2, 2, 1,  z13, l2x11, l2y21 )
 setgopt(di2, 2, 1, "title","bank notes") 
 setgopt(di2, 2, 1, "xlabel","Z[,1]","ylabel","Z[,3]","border",0)
 show(di2, 2, 2,  z23, l2x22, l2y21 )
 setgopt(di2, 2, 2, "title","bank notes") 
 setgopt(di2, 2, 2, "xlabel","Z[,2]","ylabel","Z[,3]","border",0)
 setgopt(di2, 1, 2, "border",0)
;
 plot3d(3,z)
;
"coordinates w"
tw
"coordinates z"
tz
"lambda"
lambda
"tau"
tau=cumsum(lambda)/sum(lambda)
tau
 ;
