; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      rows cols matrix diag eigsm sort string grxline gryline
;                createdisplay show setmaskp setgopt
; ----------------------------------------------------------------------------
;   Macro        SMSdecofood
; ----------------------------------------------------------------------------
;   Description  SMSdecofood computes a spectral decomposition of the French 
;                food data  and gives a repesentation of food expenditures 
;                and family types in two dimensions       
; ----------------------------------------------------------------------------
 x=read("food")                 ; reads the food data 
 library("graphic")             ; loads graphic library
 x=x[,2:cols(x)]
 n=rows(x)                      ; rows of data matrix 
 p=cols(x)                      ; columns of data matrix 
;                                
 one=matrix(n,n)
 h=diag(matrix(n))-one./n       ; centering matrix 
 d=diag(1./sqrt(sum((x-mean(x))^2)'/n))
 xs=h*x*d                       ; standardized data
;
 xs=xs./sqrt(n)                
 xs2=xs'*xs 
 {lambda, gamma}=eigsm(xs2)     ; spectral decomposition 
;
 tmp=sort(lambda~gamma',-1)     ; sort by eigenvalues
 lambda=tmp[,1]
 gamma=tmp[,2:cols(tmp)]'
;
 w=gamma.*(sqrt(lambda'))       ; coordinates of food 
 w=-w[,1:2]                     ; 
 z=xs*gamma                     ; coordinates of families 
               ; z=sqrt(n/p).*z ; xs' scaled by square root of p 
 z=-z[,1:2]                     ; 
;
 namew="bread"|"veget"|"fruit"|"meat "|"poult"|"milk "|"wine "
 namez="ma2"|"em2"|"ca2"|"ma3"|"em3"|"ca3"
 namez=namez|"ma4"|"em4"|"ca4"|"ma5"|"em5"|"ca5"
 tw=namew+" "+string("%6.3f", w[,1])+" "+string("%6.3f", w[,2])
 tz=namez+" "+string("%6.3f", z[,1])+" "+string("%6.3f", z[,2])
;
 setsize(500,250)
 di=createdisplay(1, 2)
 lx1=grxline(0, w[,2])          ; vertical axis
 ly1=gryline(0, w[,1])          ; horicontal axis
 lx2=grxline(0, z[,2])          ; vertical axis
 ly2=gryline(0, z[,1])          ; horicontal axis
;
 setmaskp(z, 0, 0, 0)
 setmaskp(w, 0, 0, 0)
 setmaskt(z, namez, 0, 0, 12)
 setmaskt(w, namew, 0, 0, 12)           
 show(di, 1, 1, w, lx1, ly1 )
 setgopt(di, 1, 1, "title","food","xlim",-1 | 1,"ylim", -1 |1)
 setgopt(di, 1, 1, "xlabel","W[,1]","ylabel","W[,2]","border",0)
;
 show(di, 1, 2,  z, lx2, ly2 )
 setgopt(di, 1, 2, "title","families","xlim", -2| 1.5, "ylim", -0.7 | 1) 
 setgopt(di, 1, 2, "xlabel","Z[,1]","ylabel","Z[,2]","border",0)

 di2=createdisplay(1, 2)
 show(di2, 1, 1,tw )
 show(di2, 1, 2,tz )
 ;
 xsvd=svd(xs)
 xsvd