; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      rows cols matrix diag eigsm sort string grxline gryline
;                createdisplay show setmaskp setgopt
; ----------------------------------------------------------------------------
;   Macro        SMSdecotime
; ----------------------------------------------------------------------------
;   Description  SMSdecotime computes a spectral decomposition of the time 
;                budget data  and gives a repesentation of activities 
;                and individuals in two dimensions       
; ----------------------------------------------------------------------------
 x=read("timebudget")                 ; reads the food data 
 library("graphic")             ; loads graphic library
 n=rows(x)                      ; rows of data matrix 
 p=cols(x)                      ; columns of data matrix 
;                                
 one=matrix(n,n)
 h=diag(matrix(n))-one./n       ; centering matrix 
 xs=h*x                         ; centered data
;
 xs=xs./sqrt(n)                
 xs2=xs'*xs 
 {lambda, gamma}=eigsm(xs2)     ; spectral decomposition 
;
 tmp=sort(lambda~gamma',-1)     ; sort by eigenvalues
 lambda=tmp[,1]
 gamma=tmp[,2:cols(tmp)]'
;
 w=gamma.*(sqrt(lambda'))       ; coordinates of food 
 w=w[,1:2]                      ; 
 z=xs*gamma                     ; coordinates of families 
 z=z[,1:2]                      ; 
;
 namew="prof"|"tran"|"hous"|"kids"|"shop"|"pers"|"eat"|"slee"|"tele"|"leis"
 namez="maus"|"waus"|"wnus"|"mmus"|"wmus"|"msus"|"wsus"|"mawe"
 namez=namez|"wawe"|"wnwe"|"mmwe"|"wmwe"|"mswe"|"wswe"|"mayo"
 namez=namez|"wayo"|"wnyo"|"mmyo"|"wmyo"|"msyo"|"wsyo"|"maes"
 namez=namez|"waes"|"wnes"|"mmes"|"wmes"|"mses"|"wses"
;
 setsize(500,500)
 di=createdisplay(1, 1)
 di2=createdisplay(1, 1)
 lx1=grxline(0, w[,2])          ; vertical axis
 ly1=gryline(0, w[,1])          ; horicontal axis
 lx2=grxline(0, z[,2])          ; vertical axis
 ly2=gryline(0, z[,1])          ; horicontal axis
;
 setmaskp(z, 0, 0, 0)
 setmaskp(w, 0, 0, 0)
 setmaskt(z, namez, 0, 0, 20)
 setmaskt(w, namew, 0, 0, 20)           
 show(di, 1, 1, w, lx1, ly1 )
 setgopt(di, 1, 1, "title","activities")
 setgopt(di, 1, 1, "xlabel","W[,1]","ylabel","W[,2]","border",0)
;
 show(di2, 1, 1,  z, lx2, ly2 )
 setgopt(di2, 1, 1, "title","individuals") 
 setgopt(di2, 1, 1, "xlabel","Z[,1]","ylabel","Z[,2]","border",0)
;
 tau=cumsum(lambda)/sum(lambda)
;
 lambda
 tau