; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      mean cov
; ----------------------------------------------------------------------------
;   Macro        SMSdisccar
; ----------------------------------------------------------------------------
;   Description  SMSdisccar demonstrates ML discrimination rule 
;                for car data 
; ----------------------------------------------------------------------------
library("xplore")
library("stats")
x=readm("carc")
txt=x.text
x=x.double
reg=x[,13]
x=2.352*100/x[,2]
n=rows(x)
;
;true=(xt[,14].>median(xt[,14]))
;true=x[,4]
;
x1=paf(x,reg==1)           
x2=paf(x,reg==2)                     
x3=paf(x,reg==3)                     
;
m1=mean(x1)             ; mean 1
m2=mean(x2)             ; mean 2
m3=mean(x3)             ; mean 3
m12=(m1+m2)/2             ; mean of all 
m23=(m2+m3)/2             ; mean of all 
m13=(m1+m3)/2             ; mean of all 
;
s=((rows(x1)-1)*cov(x1)+(rows(x2)-1)*cov(x2)+(rows(x3)-1)*cov(x3))/(rows(x)-3)    
                                 ; common variance matrix
alloc1=1.*((x-m12).*inv(s).*(m1-m2)>0).*((x-m13).*inv(s).*(m1-m3)>0)
alloc2=2.*((x-m12).*inv(s).*(m2-m1)>0).*((x-m23).*inv(s).*(m2-m3)>0)
alloc3=3.*((x-m13).*inv(s).*(m3-m1)>0).*((x-m23).*inv(s).*(m3-m2)>0)
rule12=m12
rule23=m23
rule13=m13
alloc=alloc1+alloc2+alloc3
{x1,x2,tab}=table2(reg~alloc)
aper=1-sum(xdiag(tab))/sum(sum(tab)')
"APER"
aper
;reg=alloc
mist=(alloc!=reg)
alphx=x
randomize(1)
plx=alphx~(reg+0.1*normal(rows(reg)))
col=(reg)
art=reg+1+(mist*5)+mist.*(reg==3)
setmaskp(plx, col, art, 8)
xline12=grxline(rule12,0.8|2.2)
xline23=grxline(rule23,1.8|3.2)
xline13=grxline(rule13,0.8|3.2)
setsize(600,200)
axesoff()
disp=createdisplay(1,1)
show(disp,1,1,plx,xline12,xline13,xline23)
setgopt(disp,1,1,"xoffset",0|0,"yoffset",0|0,"border",0)