; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      mean cov inv sum denest setmaskp setmaskl createdisplay show setgopt
; ----------------------------------------------------------------------------
;   Macro        SMSdisfwais
; ----------------------------------------------------------------------------
;   Description  SMSdisfwais perform a fisher discrimination analysis 
;                of WAIS data set 
; ----------------------------------------------------------------------------
  library("xplore")
  x=read("wais")         ; reads the bank data
;
  xxg=x[1:12,3:6]
  xxf=x[13:49,3:6]
;
  xg=xxg
  xf=xxf
; 
  ng=rows(xg)
  nf=rows(xf)
;
  mg=mean(xg)             ; mean of genuine notes
  mf=mean(xf)             ; mean of forged notes
  m=(mf+mg)/2             ; mean of all notes
;
  w=((ng-1)*cov(xg)+(nf-1)*cov(xf))  ; matrix w for within-sum-of-squares
  d=mg-mf                 ; vector d
  a=inv(w)*d'             ; inverse of w times d
;
setenv("outputformat","% 8.4f")
  "a"
  a
;
;
  yg=(xxg-m)*a             ; projection of group 1
  yf=(xxf-m)*a             ; projection of group 2
;
  xgtest=(xxg-m)*a
  "misclassified group 1"
  sum(xgtest.<0)          ; counts number of misclassified
                          ; group 1 
  xftest=(xxf-m)*a 
  "misclassified group 2"
  sum(xftest.>0)          ; counts number of misclassified  
                         ; group 2  
 APER=(sum(xgtest.<0)+sum(xftest.>0))/rows(x)

 "APER"
 APER

 proc (count1,count2)=main(xxg,xxf)
    ng=rows(xxg)
    nf=rows(xxf)

    count1=0

    i=1
    while (i<=nf) 
      xg=xxg
      xf=paf(xxf,(1:nf)!=i)
      x=xxf[i,]
;
      mg=mean(xg)             ; mean of genuine notes
      mf=mean(xf)             ; mean of forged notes
      m=(mf+mg)/2             ; mean of all notes
;
      w=((ng-1)*cov(xg)+(nf-1)*cov(xf))  ; matrix w for within-sum-of-squares
      d=mg-mf                 ; vector d
      a=inv(w)*d'             ; inverse of w times d
;
      yf=(x-m)*a             ; projection of x
      count1=count1+(yf>0)
      i=i+1
    endo

    count2=0
   
    i=1
    while (i<=ng) 
      xf=xxf
      xg=paf(xxg,(1:ng)!=i)
      x=xxg[i,]
;
      mg=mean(xg)             ; mean of genuine notes
      mf=mean(xf)             ; mean of forged notes
      m=(mf+mg)/2             ; mean of all notes
;
      w=((ng-1)*cov(xg)+(nf-1)*cov(xf))  ; matrix w for within-sum-of-squares
      d=mg-mf                 ; vector d
      a=inv(w)*d'             ; inverse of w times d
;
      yg=(x-m)*a             ; projection of x
      count2=count2+(yg<0)
      i=i+1
    endo

 
 endp

 
 {c1,c2}=main(xg,xf)
 aer=(c1+c2)/(rows(xg)+rows(xf))
 "misclassified group 1 (leave one out)"
 c2
 "misclassified group 2 (leave one out)"
 c1
 "AER"
 aer
