; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also     grcontour2 read setmaskp show
; ----------------------------------------------------------------------------
;   Macro       SMSdrafcar
; ----------------------------------------------------------------------------
;   Description  SMSdrafcar computes a Draftman Plot and Density Contours 
;                for columns 2 (price), 3 (mileage), 9 (weight) and 10
;                (length) of the cars data ("carc.dat")
; ----------------------------------------------------------------------------
proc()=main()
 x=read("carc")
 xt=x[,14]
 x=x[,2:3]~x[,9:10]
 p = cols(x)
 n=rows(x)
; color=2*xt
 color=0
; layout=7*matrix(n)+xt
 layout=xt+1
 di=createdisplay(p,p)
 i=0
 while (i.<p)
  i=i+1
  j=0
   while (j.<p)
    j=j+1
    if (i>j)
     xx=x[,j]~x[,i]
     nd=15                            ; number of grid points in each dimension
     nd=nd*matrix(cols(xx))
     d=(max(xx)-min(xx))'./(nd-1)     ; binwidth in each dimension
     xg=sort(grid(min(xx)',d,nd))
     h=2.6073*sqrt(var(xx))*n^(-1/6)  ; bandwidth a la Scott's rule of thumb
     one=matrix(n)
     fh=denxestp(xx,h,"qua",xg)
     fh[,3]=fh[,3]/max(fh[,3])        
;
     c  = (1:11)/12                   ; contours levels 
     col=(0:6)|(0:3)
     g = grcontour2(fh,c,col)         ; macro for contours 
     show(di,j,i,g)
     xx=x[,j]~x[,i]
     setmaskp(xx, color, layout, 5)
     show(di,i,j,xx)
     setgopt(di,i,j,"xlabel"," ","ylabel"," ")
     setgopt(di,i,j,"xorigin",-1,"yorigin",-1,"xmajor",100000,"ymajor",100000)
     setgopt(di,i,j,"xvalue",0|1,"yvalue",0|1)
     setgopt(di,j,i,"xlabel"," ","ylabel"," ")
     setgopt(di,j,i,"xorigin",-1,"yorigin",-1,"xmajor",100000,"ymajor",100000)
     setgopt(di,j,i,"xvalue",0|1,"yvalue",0|1)
     endif
  endo
 endo
show(di, 1, 1, "price") 
show(di, 2, 2, "mileage") 
show(di, 3, 3, "weight") 
show(di, 4, 4, "length") 
endp
library("graphic")
library("smoother")
main()  
