library("plot")
; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      grid min max readvalue sqrt
; ----------------------------------------------------------------------------
;   Macro        SMSellipse
; ----------------------------------------------------------------------------
;   Description  SMSellipse draws an iso-distance ellipse with parameter rho
;   						 and diameter d.	
;---------------------------------------------------------------------------
ValueNames = "rho=" | "d=" 						; reads values
defaults = 0.5 | 1 
v = readvalue(ValueNames, defaults)
;
rho = v[1,]
d = v[2,]
;
n = 101
;
x = grid (-d, (2*d/(n-1)), n)					; the x-points
;
y1 = rho*x+sqrt((rho^2-1)*4*(x^2-d^2))/2		; y-points
;y1
y2 = rho*x-sqrt((rho^2-1)*4*(x^2-d^2))/2		
;y2
minx = min(x)
maxx = max(x)
miny = min(y1|y2)
maxy = max(y1|y2)
mn = min(minx|miny)
mx = max(maxx|maxy)
;
y1 = setmask(x~y1, "line")					; creates the line
y2 = setmask(x~y2, "line")
;
axesoff()
axes=graxes((mn-0.05~mn-0.05)|(mx+0.05~mx+0.05), "origin", 0.0|0.0,"xticks",minx|0|maxx,"xfmtstr","%2.0f","yticks",miny|0|maxy, "yfmtstr","%2.0f")
; axes
di = createdisplay(1,1)
show(di,1,1,y1,y2,axes)
setgopt(di,1,1,"title", string("d = %4.2f",d) + string("   rho = %4.2f",rho),"border",0)

