; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     matrix normal plotface
; -----------------------------------------------------------------------
;   Macro       SMSfacenorm
; -----------------------------------------------------------------------
;   Description  SMSfacenorm computes Flury faces for N(0,1)-distributed 
;								 data (first 50 observation) and for N(2,1)-distributed
;								 data (51. -100. observation). 
; -----------------------------------------------------------------------

library("plot")					 ; loads library plot
q=0.*matrix(1,36)   ; do not use any facepart
q[,13]=1            ; right face line
q[,14]=1            ; right darkness of hair
q[,31]=1            ; left face line
q[,32]=1            ; left darkness of hair
;
randomize(50)
x = normal(50)			; generates 50 standard normal distributed data
y = normal(50)+(2)	; generates 50 normal distributed data with mean 2
z = x|y							; puts the data together
;     
setsize(400,640)
plotface(z,q,5,10)   ; plots the Flury faces  

