; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      read factoranalysis varimax
; ----------------------------------------------------------------------------
;   Macro        SMSfacthletic
; ----------------------------------------------------------------------------
;   Description  SMSfacthletic performs factor analysis of the US crime
;		 data set
;
; ----------------------------------------------------------------------------
library("xplore")
library("stats")
library("plot")
;
x=readm("athleleticrecord.dat")                      ; read data
t=x.text
y=x.double
name="Athletic records"
n=rows(y)
p=cols(y)
k=3
setenv("outputformat","%8.4f")
;b=factoranalysis(y,3,"PCM",10)
;b=factoranalysis(y,3,"PFM",10)
b=factoranalysis(y,k,"MLM",10)
varim=varimax(b.loadings)
"  Q1       Q2       comm.    spec.   "
varim~b.communalities~b.specifics
labels="100m"|"200m"|"400m"|"800m"|"1.5km"|"5km"|"10km"|"mara"
q12=setmask(varim[,1|2],"text",labels)
q23=setmask(varim[,2|3],"text",labels)
q13=setmask(varim[,1|3],"text",labels)
;
;
brt=n-1-(2*p+4*k+5)/6
df=((p-k)^2-p-k)/2
test=brt*(log(det(varim*varim'+diag(b.specifics)))-log(det(corr(y))))
"     k       d.f.   test     crit.v.  p-value "
k~df~test~qfc(0.95,df)~(1-cdfc(test,df))
;
;"p-value for test of k factors"
;b.pvalue
;
ucircle=cos((0:360)/180*pi)~sin((0:360)/180*pi)
ucircle=setmask(ucircle,"line","thin","dashed")
xline=setmask(#(-1.1,1.1)~#(0,0),"line")
yline=setmask(#(0,0)~#(-1.1,1.1),"line")
diq=createdisplay(2,2)
show(diq,1,1,q12,ucircle,xline,yline)
show(diq,2,2,q23,ucircle,xline,yline)
show(diq,2,1,q13,ucircle,xline,yline)
setgopt(diq,1,1,"title",name,"xlabel","q1","ylabel","q2","border",0)
setgopt(diq,2,2,"title",name,"xlabel","q2","ylabel","q3","border",0)
setgopt(diq,2,1,"title",name,"xlabel","q1","ylabel","q3","border",0)
setgopt(diq,1,2,"border",0)
; factor scores
z=(y-mean(y))./sqrt(var(y))
fs=z*inv(corr(y))*varim
labl = t
cols = matrix(n)
fs12=setmask(fs[,1|2],"text",labl,"color",cols)
fs23=setmask(fs[,2|3],"text",labl,"color",cols)
fs13=setmask(fs[,1|3],"text",labl,"color",cols)
dif=createdisplay(2,2)
show(dif,1,1,fs12)
show(dif,2,2,fs23)
show(dif,2,1,fs13)
setgopt(dif,1,1,"title","first vs. second factor scores","xlabel","f1","ylabel","f2","border",0)
setgopt(dif,2,2,"title","second vs. third factor scores","xlabel","f2","ylabel","f3","border",0)
setgopt(dif,2,1,"title","first vs. third factor scores","xlabel","f1","ylabel","f3","border",0)
setgopt(dif,1,2,"border",0)

dum=t[sort((1:n)~fs[,1],2),]~t[sort((1:n)~fs[,2],2),]~t[sort((1:n)~fs[,3],2),]
"10 best"
dum[1:10]
"10 worst"
dum[(n-9):n,]




