; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      read factoranalysis varimax
; ----------------------------------------------------------------------------
;   Macro        SMSfactsigma
; ----------------------------------------------------------------------------
;   Description  SMSfactsigma performs factor analysis of the artifical
;		 correlation matrix
;
; ----------------------------------------------------------------------------
library("xplore")
library("stats")

proc(Q,PSI)=PFM(R)
  PSIini=diag(1./xdiag(inv(R)))		 	; preliminary estimate for psi
  PSI=PSIini
  i=1
  k=1    
  {eigval, eigvec}=eigsm(R-PSI) 
  sorted=sort(eigval~eigvec', -1) 		; sort by eigenvalues
  eigval=sorted[,1]
  do  
     {eigval, eigvec}=eigsm(R-PSI) 		; spectral decomposition of the reduced corr.matrix
     aeig=abs(eigval)
     sorted=sort(aeig~eigval~eigvec', -1) 		; sort by eigenvalues
     eigval=sorted[,2]
  
     eigvec=sorted[,3:(rows(eigval)+2)]'
     eigval=eigval[1:k]
     eigvec=eigvec[,1:k]
     Q=sqrt(eigval)'.*eigvec
     PSIold=PSI
     PSI=diag(xdiag(R)-xdiag(Q*Q'))
;     PSI=diag((xdiag(PSI)>0).*xdiag(PSI)+0.3*(xdiag(PSI)<0))
     i=i+1
  until((i>=100))
endp

R=(1~0.9~0.7)|(0.9~1~0.4)|(0.7~0.4~1)

ofm=PFM(R)

ofm 
ofm.Q*ofm.Q'+ofm.PSI