; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      read factoranalysis varimax
; ----------------------------------------------------------------------------
;   Macro        SMSfactushealth
; ----------------------------------------------------------------------------
;   Description  SMSfactushealth performs factor analysis of the US health
;		 data set
;
; ----------------------------------------------------------------------------
library("xplore")
library("stats")
library("plot")
;
x=readm("ushealth")                      ; read data
t=x.text
y=x.double[,3:9]
reg=x.double[,12]
name="US health"
n=rows(y)
p=cols(y)
k=3
setenv("outputformat","%8.4f")
;b=factoranalysis(y,3,"PCM",10)
;b=factoranalysis(y,3,"PFM",10)
b=factoranalysis(y,k,"MLM",10)
varim=varimax(b.loadings)
"  Q1       Q2       comm.    spec.   "
varim~b.communalities~b.specifics
labels="acc"|"card"|"canc"|"pul"|"pneu"|"diab"|"liv"
;c=factorrot(varim,labels)  
q12=setmask(varim[,1|2],"text",labels)
q23=setmask(varim[,2|3],"text",labels)
q13=setmask(varim[,1|3],"text",labels)
;
;
brt=n-1-(2*p+4*k+5)/6
df=((p-k)^2-p-k)/2
test=brt*(log(det(varim*varim'+diag(b.specifics)))-log(det(corr(y))))
"     k       d.f.   test     crit.v.  p-value "
k~df~test~qfc(0.95,df)~(1-cdfc(test,df))
;
;"p-value for test of k factors"
;b.pvalue
;
ucircle=cos((0:360)/180*pi)~sin((0:360)/180*pi)
ucircle=setmask(ucircle,"line","thin","dashed")
xline=setmask(#(-1.1,1.1)~#(0,0),"line")
yline=setmask(#(0,0)~#(-1.1,1.1),"line")
diq=createdisplay(2,2)
show(diq,1,1,q12,ucircle,xline,yline)
show(diq,2,2,q23,ucircle,xline,yline)
show(diq,2,1,q13,ucircle,xline,yline)
setgopt(diq,1,1,"title",name,"xlabel","q1","ylabel","q2","border",0)
setgopt(diq,2,2,"title",name,"xlabel","q2","ylabel","q3","border",0)
setgopt(diq,2,1,"title",name,"xlabel","q1","ylabel","q3","border",0)
setgopt(diq,1,2,"border",0)
; factor scores
z=(y-mean(y))./sqrt(var(y))
fs=z*inv(corr(y))*varim
labl = t
;cols = matrix(rows(y))
cols=reg
fs12=setmask(fs[,1|2],"text",labl,"color",cols)
 setmaskt(fs12,labl,0,3,10)
 setmaskp(fs12,0,cols+1,5)
fs23=setmask(fs[,2|3],"text",labl,"color",cols)
  setmaskt(fs23,labl,0,3,10)
  setmaskp(fs23,0,cols+1,5)
fs13=setmask(fs[,1|3],"text",labl,"color",cols)
  setmaskt(fs13,labl,0,3,10)
  setmaskp(fs13,0,cols+1,5)
dif=createdisplay(2,2)
show(dif,1,1,fs12)
show(dif,2,2,fs23)
show(dif,2,1,fs13)
setgopt(dif,1,1,"title","first vs. second factor scores","xlabel","f1","ylabel","f2","border",0)
setgopt(dif,2,2,"title","second vs. third factor scores","xlabel","f2","ylabel","f3","border",0)
setgopt(dif,2,1,"title","first vs. third factor scores","xlabel","f1","ylabel","f3","border",0)
setgopt(dif,1,2,"border",0)
