; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      read factoranalysis varimax
; ----------------------------------------------------------------------------
;   Macro        SMSfactvocab
; ----------------------------------------------------------------------------
;   Description  SMSfact performs factor analysis of the vocabulary
;		 data set
;
; ----------------------------------------------------------------------------
library("xplore")
library("stats")
library("plot")
;
x=read("vocabulary")                      ; reads the data file
name="Vocabulary: dot-plot of factor scores"
y=x[,2:5]                           
n=rows(y)
p=cols(y)
k=1
setenv("outputformat","%8.4f")
;b=factoranalysis(y,3,"PCM",10)
;b=factoranalysis(y,3,"PFM",10)
b=factoranalysis(y,k,"MLM",10)
;varim=varimax(b.loadings)
"  Q1       Q2       comm.    spec.   "
b.loadings~b.communalities~b.specifics
labels="8"|"9"|"10"|"11"
;
q=b.loadings
;
brt=n-1-(2*p+4*k+5)/6
df=((p-k)^2-p-k)/2
test=brt*(log(det(q*q'+diag(b.specifics)))-log(det(corr(y))))
"     k       d.f.   test     crit.v.  p-value "
k~df~test~qfc(0.95,df)~(1-cdfc(test,df))
;
q=setmask(b.loadings~(matrix(4)),"text",labels)
;
;
"p-value for test of k factors"
b.pvalue
;
; factor scores
z=(y-mean(y))./sqrt(var(y))
fs=z*inv(corr(y))*b.loadings
labl = string("%2.0f",1:rows(y))
cols = matrix(rows(y))
dum=setmask((min(fs)|max(fs))~(0.1|1.1),"color",7)
randomize(1234)
fs=setmask(fs~(0.35+uniform(rows(fs))/2),"text",labl,"color",cols)
setsize(600,300)
dif=createdisplay(1,1)
show(dif,1,1,fs,dum)
setgopt(dif,1,1,"title",name,"xlabel","f1","ylabel"," ","border",0,"yorigin",-1,"ymajor",3,"yoffset",15|18,"xoffset",1|1)
