; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     grhist createdisplay show setgopt
; -----------------------------------------------------------------------
;   Macro       SMShiscar
; -----------------------------------------------------------------------
;   Description  SMShiscar computes histograms for the mileage (Variable 3) 
;                of US, Japanese and European cars from carc.dat, 
;                respectively
; -----------------------------------------------------------------------
 library("graphic")
 x=read("carc")                   ; reads the whole car data file
 x1=paf(x[,3],x[,14].=1)          ; mileage for US cars
 x2=paf(x[,3],x[,14].=2)          ; mileage for Japanese cars
 x3=paf(x[,3],x[,14].=3)          ; mileage for European cars
 x = x[,3]												; mileage for all cars
 ;
 bp1=grhist(x1)                    ; histogram for US cars
 bp2=grhist(x2)                    ; histogram for Japanese cars
 bp3=grhist(x3)                    ; histogram for European cars
 bp = grhist(x)
 
 go2=grmove(bp2,#(35,0))           ; moves plot of Japanese to right
 go3=grmove(bp3,#(70,0))           ; moves plot of European to right
 
 axeson()

 di=createdisplay(2,2)            ; create display "di"
 show(di,1,1,bp1)                 ; shows the histogram of US in the upper left window 
 show(di,1,2,bp2)									; shows the histogram of Japanese in the upper right window
 show(di,2,1,bp3)									; shows the histogram of European in the lower left window
 show(di,2,2,bp)									; shows the histogram of all cars in the lower right window
 ;
 ylabl="mileage"									; sets the labels of the graph
 setgopt(di,1,1,"ylabel",ylabl,"xlabel","U.S. cars", "border",0)
 setgopt(di,1,2,"ylabel",ylabl,"xlabel","Japanese cars", "border",0)
 setgopt(di,2,1,"ylabel",ylabl,"xlabel","European cars", "border",0)
 setgopt(di,2,2,"ylabel",ylabl,"xlabel","All cars", "border",0)



