; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      isoreg distance eigensm
; ----------------------------------------------------------------------------
;   Macro        SMSnmdsathletic
; ----------------------------------------------------------------------------
;   Description  SMSnmdsathletic computes the 2D map of US crimes
;                using nonmetric multidimensional scaling
; ----------------------------------------------------------------------------
proc (X)=nonMDS(Dist,text)
 if (rows(Dist)<>rows(text))
  text=string("%2.0f",1:rows(Dist))
 endif
 alpha=0.2
 ; calculate configuration of points in two dimensions
 A=(Dist.^2).*(-0.5)
 n=rows(Dist)
 nn=n^2
 I=diag(matrix(n))
 u=matrix(n)
 H=I-(1/6*(u*u'))
 B=H*A*H
 G=eigensm(B)
 G1=(G.vectors[,1])~(G.vectors[,2])
 G2=diag(G.values[1:2,])
 X=G1*(G2.^0.5)
; X=normal(rows(Dist),2)
 setsize(400,400)
 MDS=createdisplay(1,1)
 color=0
 position=3
 pic=X
 X1=X
 setmaskp(pic,0,0,0)
 setmaskt(pic,text,color,position,16)
 show(MDS,1,1,pic)
 ; iterate Shepard-Kruskal until convergence
 change=1
 STRESS1=1
 iter=0
 n=rows(Dist)
 nn=n^2
 while (((change)>0.0000001)&&(iter<10000))
; while (iter<0)
  iter=iter+1
  ; isotonic regression
  Dist1=vec(distance(X,"euclid"))~floor((0:(nn-1))/n+1)
  Dist1=Dist1~((1:(nn))-(Dist1[,2]-1)*n)
  Dist1=vec(Dist)~Dist1 
  Dist1=sort(Dist1,1)
  Dist2=isoreg(Dist1[,2])
  STRESS0=STRESS1
  STRESS1=(Dist2-Dist1[,1])'*(Dist2-Dist1[,1])/(2*sum(Dist1[,1]^2))
  change=STRESS0-STRESS1
  ; update X
  Xnew=X
  Dist1=Dist1~Dist2
  Dist1=sort(Dist1,4|3)
  D=reshape(Dist1[,2],n|n)+I
  DH=reshape(Dist1[,5],n|n)+I
  shift=alpha*(1-(DH./D))/(n-1)
  i=0
  while (i<n)
   i=i+1 
   Xnew[i,]=X[i,]+sum(shift[,i].*(X.-(X[i,])))
  endo
 X=Xnew 
 endo
  pic=X
  comsc=min(X[,1]|X[,2])|max(X[,1]|X[,2])
  comra=(comsc[2]-comsc[1])/20
  comsc=comsc+(-comra|comra)
  ym=floor(comra*6)
  setmaskp(pic,0,0,0)
  setmaskt(pic,text,color,position,16)
  show(MDS,1,1,pic)
;  setgopt(MDS,1,2,"xlim",comsc,"ylim",comsc,"xmajor",ym,"ymajor",ym,"title","last iteration")
  setgopt(MDS,1,1,"xlim",comsc,"ylim",comsc,"xmajor",ym,"ymajor",ym,"title","Athletic records","border",0)
endp

library("graphic")
library("xplore")
data=readm("athleleticrecord.dat")
x=data.double
;x=(x-min(x))/(max(x)-min(x))
x=(x-mean(x))/sqrt(var(x))
text=data.text
; distance matrix
Dist=distance(x,"euclid")
X=nonMDS(Dist,text)
;X

