; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also      createdisplay grpcp setgopt show 
; ----------------------------------------------------------------------------
;   Macro        SMSpcpcar
; ----------------------------------------------------------------------------
;   Description  SMSpcpcar computes a parallel coordinate plot for the 
;   observations cars data set ("carc.dat").
;---------------------------------------------------------------------------
 x=read("carc")                     ; reads data
 library("graphic")
 z=x[,2:cols(x)]
 z=(z-min(z))./(max(z)-min(z))      ; standardize the data     
 
 col=(x[,cols(x)])											; sets the colors (green for U.S., red for Japanese and yellow for European cars)
 pcp2= grpcp(z)  
                ; parallel coordinate plot
 pcp2.lstyle=1*(col==1)+2*(col==2)+9*(col==3)
 pcp2.lcolor=1*(col==1)+0*(col==2)+4*(col==3)
 pcp2.lsize=matrix(rows(x))
; correct the not so nice looking lines in postscript
 pcp2.lines[72,13]=0
 pcp2.lines[72,12]=0
 pcp2.lines[71,13]=0
 pcp2.lines[71,12]=0
 pcp2.lines[71,11]=0
 pcp2.lines[71,10]=0
;
 axesoff()
 axes=graxes((0.5~-0.02)|(13.5~1.02), "origin", 0.5|-0.02,"xticks",1:13,"xtext",1:13,"xfmtstr","%2.0f","yticklen",0.05,"yticks",0|1)
 di=createdisplay(1,1)             ; creates display
 show(di,1,1,pcp2,axes)            ; shows plot

 setgopt(di,1,1,"title","Cars data", "border",0)

