; ----------------------------------------------------------------------------
; EBook         sms
; ----------------------------------------------------------------------------
;  See_also  read grid setmaskp setmaskt createdisplay show setgopt
; ----------------------------------------------------------------------------
;   Macro        SMSportfol
; ----------------------------------------------------------------------------
;   Description  SMSportfol computes the optimal portfolio weights 
;                with monthly returns of six US firms from 
;                Jan'78 to Dec'87. the optimal portfolio is compared
;                with an equally weighted one.
; ----------------------------------------------------------------------------
  library("xplore")
;
  x1=read("ibm")               ; returns for IBM
  x2=read("panam")             ; returns for Pan Am. Airways
  x3=read("delta")             ; returns for Delta Airlines
  x4=read("coned")             ; returns for Cons. Edison
  x5=read("gerber")            ; returns for Gerber
  x6=read("texaco")            ; returns for Texaco
  x7=read("dec")               ; returns for Digital Equipment Company
;
  ix=1|2|3|4|5|6|7             ; CHOOSE assets to use!!
  ix=1|2|7
;
  x=x1~x2~x3~x4~x5~x6~x7       ; MVAportfolio of all assets
  x=x[,ix]                     ; use only ix
;
  s1=inv(cov(x))               ; inverse of empirical covariance    
  one=matrix(cols(x))          ; vector of one's    
  c2=(s1*one)./(one'*s1*one)   ; optimal weights    
  c1=one./sum(one)             ; equal weights 
;   
  q1=x*c1                      ; optimal portfolio returns    
  q2=x*c2                      ; non-optimal (equal) portfolio returns    
;
  t=grid(1, 1, 120)            ; grid for time    
  d1=t~q1                      ; equal weights
  d2=t~q2                      ; optimal weights
;
  setmaskl(d1, (1:120)',0, 1, 1)  ; creates a dashed line 
  setmaskp(d1, 0, 0, 0)        ;  
  setmaskl(d2, (1:120)',0, 1, 1)  ; creates a dashed line  
  setmaskp(d2, 0, 0, 0)        ;  
;
  str=" IBM"|" Pan Am"|" Delta"|" Edison"|" Gerber"|" Texaco"
  ;str1=" IBM"|" Pan Am"
  setsize(600,600)
  di=createdisplay(2,1)
  ;setfractions(di,1|1,3|1)
  show(di,1,1,d1)
  show(di,2,1,d2)
  ;show(di,1,2,"weights"|" "|(string("%0.3f",c1)+str))
  ;show(di,2,2,"weights"|" "|(string("%0.3f",c2)+str))
  ;show(di,1,2,"weights"|" "|(string("%0.3f",c1)+str1)) ;show only IBM and Pan Am
  ;show(di,2,2,"weights"|" "|(string("%0.3f",c2)+str1)) ;show only IBM and Pan Am
  setgopt(di,1,1,"ylim",(-0.3|0.3),"yvalue",0|1,"ymajor",0.2,"title","equally weighted portfolio","border",0)
  setgopt(di,2,1,"ylim",(-0.3|0.3),"yvalue",0|1,"ymajor",0.2,"title","variance efficient portfolio","border",0)
  setgopt(di,1,1,"ylabel","Returns","xlabel","Time","xoffset",7|7,"yoffset",12|12)
  setgopt(di,2,1,"ylabel","Returns","xlabel","Time","xoffset",7|7,"yoffset",12|12)
  "variance efficient portfolio"
  c2
