; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     qff mean cov inv
; -----------------------------------------------------------------------
;   Macro       SMSprofplasma
; -----------------------------------------------------------------------
;   Description  performs profile analysis of plasma data set
;								 and for normal distributed data with chosen number of 
;								 observation
; -----------------------------------------------------------------------

; parallel profiles

x= vec(125,144,105,151,137,93,116,109,89,116)~vec(137,173,119,149,139,121,135,83,95,128)~vec(121,147,125,128,109,107,106,100,83,100)
x1=x[1:5,]
x2=x[6:10,]
n1 = rows(x1)
n2 = rows(x2)
n = n1+n2
p = cols(x1)
; estimates the mean and the variance
s1 = ((n1-1)/n1)*cov(x1)
s2 = ((n2-1)/n2)*cov(x2)
s = (n1*s1+n2*s2)/(n1+n2)
ex1 = mean(x1)'
ex2 = mean(x2)'
ex = (n1*ex1 + n2*ex2) / (n1+n2)
sinv = inv(s)
k = n1*n2*(n1+n2-p)/((n1+n2)^2*(p-1))
c=vec(1,0)~vec(-1,1)~vec(0,-1)

"are the profiles parallel?"

F = k*(c*(ex))'*(inv(c*s*c'))*(c*(ex)) ; teststatistik
F
critvalue = qff(0.95,(p-1),n1+n2-p)
critvalue

x=ex1
xx=ex2
library("plot")
xp=1:3~x
xxp=1:3~xx
dd=createdisplay(1,1)
xp=setmask(xp,"line","red")
xxp=setmask(xxp,"line","blue")
tx=2~max(x[1:3])
txx=2~max(xx[1:3])
tx=setmask(tx,"text","Group1","style","above","red")
txx=setmask(txx,"text","Group2","style","above","blue")
show(dd,1,1,xp,xxp,tx,txx)
setgopt(dd,1,1,"ylim",90|150,"ymajor",10,"title","Profiles")
setgopt(dd,1,1,"ylabel","Mean","xlabel","Treatment")


"test the equality of the parallel profiles"

k= n1*n2*(n1+n2-2)/(n1+n2)^2
u=matrix(p,1)

F = k*((u'*(ex1-ex2))^2 )/(u'*s*u) ; teststatistik
F
critvalue = qff(0.95,(1),n1+n2-2)
critvalue

"are the parallel profiles horizontal?"

c=vec(1,0)~vec(-1,1)~vec(0,-1)
k = (n1+n2-p)/(p-1)

F = k*(c*(ex1-ex2))'*(inv(c*s*c'))*(c*(ex1-ex2)) ; teststatistik
F
critvalue = qff(0.95,(p-1),n1+n2-p)
critvalue

