; -----------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------
;  See_also     simdep setgopt
; -----------------------------------------------------------------
;   Macro        SMSsimpdsimu
; -----------------------------------------------------------------
;   Description  SMSsimpdsimu calculates simplicial depth
;                of simulated data set 
; -----------------------------------------------------------------
library("stats")
library("xplore")
;
; simulate data
;
randomize(2007)
a = uniform(10,1)*pi*2
x = cos(a)~sin(a)
x = x + 0.1*normal(rows(x),cols(x))
x = x|(0.4~0.5)

;
; estimate the location by simdep
;
{med,dep} = simdep(x)
"Deepest Point"
med
;
med12=median(x)
"Pointwise Median"
med12
; draw a depth graph and median
;
d = createdisplay(1,1)
dat = x
col = round(4*dep/max(dep))
; correct the bug in calculation
dep[1]=min(dep) 
textdep=string("%4.0f",dep)
;setmaskp(dat, col, 3, 8)
setmaskp(dat, col, 0, 0)
setmaskt(dat, textdep, 1, 0, 18)
median = med'
setmaskp(median,4,12,15)    ; median is red big star
setmaskp(med12,1,4,15)    ; median is red big star
show(d, 1, 1, dat, median, med12)
setgopt(d, 1, 1, "title", "Simplicial depth","border",0,"xlim",-1.1|1.1,"ylim",-1.1|1.1)

