; ----------------------------------------------------------------------------
;  EBook         sms
; ----------------------------------------------------------------------------
;  See_also      sir2
; ----------------------------------------------------------------------------
;  Macro         SMSsir2cars
; ----------------------------------------------------------------------------
;  Description   SMSsir2cars applies the sliced inverse
;                regression algorithm (SIR II) for dimension reduction
;                on cars data set.
; ----------------------------------------------------------------------------
library("metrics")
;
m=readm("carc.dat")	
n=rows(m.double)
; get rid of the outliers
keep=1:n
x=m.double[keep,2|(5:12)]
type=m.double[keep,13]
y=m.double[keep,1]
t=m.text[keep,1]
n=rows(x)
;x=log(x-min(x)+(max(x)-min(x))/200)
x=(x-mean(x))./sqrt(var(x))
{f,g}=sir2(x,y,-10)
sg=sum(g)
g=g/sg
psi=cumsum(g)
;
di=createdisplay(2,2)
;
i=1:rows(g)
ig=i~g
setmaskp(ig,0,12,8)
;
p11=x*f[,1]~y
setmaskp(p11,1,type+2,5)
;setmaskt(p11,t,0,0,8)
p12=x*f[,2]~y
setmaskp(p12,1,type+2,5)
p21=x*f[,3]~y
setmaskp(p21,1,type+2,5)
show(di,1,1,p11)
show(di,2,1,p21)
show(di,1,2,p12)
show(di,2,2,ig,i~psi)
p123=x*f[,1:2]~y
setmaskp(p123,1,type+2,5)
library("plot")
plot(p123)
;
setgopt(di,1,1,"title","First index vs Price","xlabel","index","ylabel","response","border",0)
setgopt(di,2,1,"title","Third index vs Price","xlabel","index","ylabel","response","border",0)
setgopt(di,1,2,"title","Second index vs Price","xlabel","index","ylabel","response","border",0)
setgopt(di,2,2,"title","Scree Plot (SIR II)","xlabel","K","ylabel"," ","border",0)
"eigenvectors"
f
"eigenvalues and proportions"
g~cumsum(g)
