; ----------------------------------------------------------------------------
;  EBook         sms
; ----------------------------------------------------------------------------
;  See_also      
; ----------------------------------------------------------------------------
;  Macro         SMSsir2simu
; ----------------------------------------------------------------------------
;  Description   SMSsir2simu generates a data set and applies the sliced inverse
;                regression algorithm (SIR II) for dimension reduction.
; ----------------------------------------------------------------------------
randomize(1998)
library("metrics")
;
n=400
x=normal(n,4)
e=normal(n,1)
b1=#(1,3,0,0)
b2=#(0,0,1,-1)
i=#(1,2,3,4)
y=((x*b1)^2)+((x*b2)^4)+e
{f,g}=sir2(x,y,-20)
f1=((x*b1)^2)+((x*b2)^4)
;  m1=(x*b1)~(x*b1+((x*b1)^3)+4*((x*b2)^2))
;  m2=(x*b2)~(x*b1+((x*b1)^3)+4*((x*b2)^2))
m1=(x*b1)~y
m2=(x*b2)~y
m1=sort(m1)
m2=sort(m2)
sg=sum(g)
g=g/sg
psi=cumsum(g)
;
di=createdisplay(2,2)
;
ig=i~g
setmaskp(ig,0,12,8)
;
p11=x*f[,1]~y
setmaskp(p11,1,2,2)
;p12=x*f[,1]~x*f[,2]~y
;setmaskp(p12,1,2,2)
p12=x*f[,2]~y
setmaskp(p12,1,2,2)
p21=x*f[,3]~y
setmaskp(p21,1,2,2)
show(di,1,1,p11)
show(di,2,1,p21)
show(di,1,2,p12)
show(di,2,2,ig,i~psi)
;
setgopt(di,1,1,"title","First index vs Response","xlabel","index","ylabel","response","border",0)
setgopt(di,2,1,"title","Third index vs Response","xlabel","index","ylabel","response","border",0)
setgopt(di,1,2,"title","Second index vs Response","xlabel","index","ylabel","response","border",0)
setgopt(di,2,2,"title","Scree Plot (SIR II)","ylim",0|1.05,"xlabel","K","ylabel"," ","border",0)
