; ----------------------------------------------------------------------------
;  EBook         sms
; ----------------------------------------------------------------------------
;  See_also      
; ----------------------------------------------------------------------------
;  Macro         SMSsiruscomp
; ----------------------------------------------------------------------------
;  Description   SMSsiruscomp applies the sliced inverse
;                regression algorithm (SIR) for dimension reduction
;                on US companies data set.
; ----------------------------------------------------------------------------
library("metrics")
;
m=readm("uscomp2.dat")	
; get rid of the outliers
keep=(1:37)|39|(41:79)
;keep=1:79
x=m.double[keep,1|2|4|5|6]
y=m.double[keep,3]
t=m.text[keep,1]
n=rows(x)
x=log(x-min(x)+(max(x)-min(x))/200)
x=(x-mean(x))./sqrt(var(x))
{f,g}=sir(x,y,-11)
sg=sum(g)
g=g/sg
psi=cumsum(g)
;
di=createdisplay(2,2)
;
i=1:rows(g)
ig=i~g
setmaskp(ig,0,12,8)
;
p11=x*f[,1]~y
setmaskp(p11,1,2,2)
;setmaskt(p11,t,0,0,8)
p12=x*f[,2]~y
setmaskp(p12,1,2,2)
p21=x*f[,3]~y
setmaskp(p21,1,2,2)
show(di,1,1,p11)
show(di,2,1,p21)
show(di,1,2,p12)
show(di,2,2,ig,i~psi)
;
setgopt(di,1,1,"title","First index vs Market Value","xlabel","index","ylabel","response","border",0)
setgopt(di,2,1,"title","Third index vs Market Value","xlabel","index","ylabel","response","border",0)
setgopt(di,1,2,"title","Second index vs Market Value","xlabel","index","ylabel","response","border",0)
setgopt(di,2,2,"title","Scree Plot (SIR)","xlabel","K","ylabel"," ","border",0)
"eigenvectors"
f
"eigenvalues and proportions"
g~cumsum(g)
