; ----------------------------------------------------------------------------
; EBook          sms
; ----------------------------------------------------------------------------
;  See_also      svm
; ----------------------------------------------------------------------------
;   Macro        SMSsvmbankrupt
; ----------------------------------------------------------------------------
;   Description  SMSsvmbankrupt performs SVM to classify bankrupt companies
; ----------------------------------------------------------------------------

library("xplore");
library("plot");
library("xclust");
AT=read("bankruptcy.dat");
nsteps=200;
origin=#(-0.62, 0.0);
endpoints=#(0.52, 1.5);
steps=(endpoints-origin)/nsteps;
npoints=#(nsteps+1, nsteps+1);
AC=grid(origin,steps,npoints);

r=2
c=1
; 2-nd picture
;r=0.5
;c=1.0
; 3-rd picture
;r=2.0
;c=1000
; 4-th picture
;r=0.5
;c=1000
; 5-th picture
;r=5
;c=1
; 6-th picture
;r=5
;c=1000

V=svm(AT, AC, r, c);
svmplot(AT,AC,V);
title="Bankruptcy: r="+string("%1.1f",r)+", c="+string("%1.1f",c)+" "
setgopt(svmdi,1,1,"xlabel","Profitability(NI/TA)","ylabel","Leverage(TL/TA)","title",title);
z=sort(AC~V,#(1,2,3));

{lt,pt} = contour2(z, 0.0);
setmaskp(pt, 7, 9, 2);
adddata(svmdi, 1, 1, pt);

{lt,pt} = contour2(z, 1.0);
setmaskp(pt, 0, 9, 2);
adddata(svmdi, 1, 1, pt);

{lt,pt} = contour2(z, -1.0);
setmaskp(pt, 0, 9, 2);
adddata(svmdi, 1, 1, pt);

