; ----------------------------------------------------------------------------
; EBook          sms
; ----------------------------------------------------------------------------
;  See_also      svm
; ----------------------------------------------------------------------------
;   Macro        SMSsvmorange
; ----------------------------------------------------------------------------
;   Description  SMSsvmorange performs SVM on the orange peel data set
; ----------------------------------------------------------------------------

library("xplore");
library("plot");
library("xclust");



nm=200/2;
randomize(2);
x1=(2*normal(nm,1))~(2*normal(nm,1))~matrix(nm,1);
x2=(0.5*normal(nm,1))~(0.5*normal(nm,1))~(-1)*matrix(nm,1);
AT=x1|x2;


nsteps=200;
origin=#(-5.0, -5.0);
endpoints=#(5.0, 5.0);
steps=(endpoints-origin)/nsteps;
npoints=#(nsteps+1, nsteps+1);
AC=grid(origin,steps,npoints);

; 1-st picture
r=2.0
c=1.0
; 2-nd picture
;r=0.5
;c=1.0
; 3-rd picture
;r=2.0
;c=1000
; 4-th picture
;r=0.5
;c=1000
V=svm(AT, AC, r, c);

svmplot(AT,AC,V);

title="Orange Peel: r="+string("%1.1f",r)+", c="+string("%1.1f",c)+" "

setgopt(svmdi,1,1,"xlabel","X1","ylabel","X2","title",title);
z=sort(AC~V,#(1,2,3));

{lt,pt} = contour2(z, 0.0);
setmaskp(pt, 7, 9, 2);
adddata(svmdi, 1, 1, pt);

{lt,pt} = contour2(z, 1.0);
setmaskp(pt, 0, 9, 2);
adddata(svmdi, 1, 1, pt);

{lt,pt} = contour2(z, -1.0);
setmaskp(pt, 0, 9, 2);
adddata(svmdi, 1, 1, pt);

