; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     normal qfc qff
; -----------------------------------------------------------------------
;   Macro       SMStestsim
; -----------------------------------------------------------------------
;   Description  SMStestsim tests a linear hypothesis for the  mean vector of a simulated
;                multivariate normal random sample
; -----------------------------------------------------------------------
;   Author Jasmin John
; -----------------------------------------------------------------------

randomize(123)

p=2
n=100
;create the variables for the distribution
u=#(1,2)
u
covMatrix=#(1,0.5)~#(0.5,2)
covMatrix
;calculate the standard normal
standardNormal=normal(p,n)
standardNormal
; 
{eval,evec}=eigsm(covMatrix)
covMatrix12=evec*diag(eval)*evec'
X=covMatrix12*standardNormal+u
X
;variables for the Linear Hypothesis testing
A=#(2)~#(-1)
A
a=0.2
a
xBar=mean(X,p)
xBar
;Test Problem 5 covMatrix known
test1=n*(A*xBar-a)'*inv(A*covMatrix*A')*(A*xBar-a)
test1
critval1=qfc(0.95,1)
critval1
;Test Problem 6 covMatrix unknown
S=cov(X')
test2=(n-1)*(A*xBar-a)'*inv(A*S*A')*(A*xBar-a)
test2
critval2=qff(0.95,1,n-1)
critval2
    


