; -----------------------------------------------------------------------
; EBook         sms
; -----------------------------------------------------------------------
;  See_also     qff mean cov
; -----------------------------------------------------------------------
;   Macro       SMStestuscomp
; -----------------------------------------------------------------------
;   Description  SMStestuscomp tests equality of two mean vectors for the 
;		 US companies data set
; -----------------------------------------------------------------------
;   Author       Rong Sun, Burcin Sezgen, Lars Rohrschneider, Thomas Diete 
; -----------------------------------------------------------------------

library("xplore")
y = read ("uscomp2.dat")	
x=y[,2:7]
x1=x[3:17,]
x2=x[43:52,]
n1 = rows(x1)
n2 = rows(x2)
n = n1+n2
p = cols(x1)

; estimates the mean and the variance
s1 = ((n1-1)/n1)*cov(x1)
s2 = ((n2-1)/n2)*cov(x2)
s = (n1*s1+n2*s2)/(n1+n2)
ex1 = mean(x1)
ex2 = mean(x2)
sinv = inv(s)
k = (n1*n2*(n-p-1))/(p*(n^2))

; computes the test statistic
F = k*(ex1-ex2)*sinv*trans(ex1-ex2) 
F
critvalue=qff(0.95,p,n-p-1)
critvalue
; computes the simultaneous confidence intervals
upper = (ex1-ex2)'+sqrt(qff(0.95, p, n-p-1)*(1/k)*xdiag(s))
lower = (ex1-ex2)'-sqrt(qff(0.95, p, n-p-1)*(1/k)*xdiag(s))

confint = lower~upper
confint

